/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-23 at 23:46:00 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

/**
 * Template for notifications list response.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Admin Directory API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Notifications extends com.google.api.client.json.GenericJson {

  /**
   * List of notifications in this page.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Notification> items;

  static {
    // hack to force ProGuard to consider Notification used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Notification.class);
  }

  /**
   * The type of the resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Token for fetching the next page of notifications.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * Number of unread notification for the domain.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer unreadNotificationsCount;

  /**
   * List of notifications in this page.
   * @return value or {@code null} for none
   */
  public java.util.List<Notification> getItems() {
    return items;
  }

  /**
   * List of notifications in this page.
   * @param items items or {@code null} for none
   */
  public Notifications setItems(java.util.List<Notification> items) {
    this.items = items;
    return this;
  }

  /**
   * The type of the resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The type of the resource.
   * @param kind kind or {@code null} for none
   */
  public Notifications setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Token for fetching the next page of notifications.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * Token for fetching the next page of notifications.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public Notifications setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  /**
   * Number of unread notification for the domain.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getUnreadNotificationsCount() {
    return unreadNotificationsCount;
  }

  /**
   * Number of unread notification for the domain.
   * @param unreadNotificationsCount unreadNotificationsCount or {@code null} for none
   */
  public Notifications setUnreadNotificationsCount(java.lang.Integer unreadNotificationsCount) {
    this.unreadNotificationsCount = unreadNotificationsCount;
    return this;
  }

  @Override
  public Notifications set(String fieldName, Object value) {
    return (Notifications) super.set(fieldName, value);
  }

  @Override
  public Notifications clone() {
    return (Notifications) super.clone();
  }

}
